/********************************************************************************
* Fast and Exact Gate Sizing by Lagrangian Relaxation                           *
* File name: Gate.h; interface for the CGate class                              *
* Author: Yu-Hao Wang						         	*
* Created      : 09/28/01						        *
* Last modified: 02/01/02					        	*
*********************************************************************************/

#define Milli pow(10, -3)
#define Micro pow(10, -6)
#define Nano  pow(10, -9)
#define Pico  pow(10, -12)
#define Femto pow(10, -15)

#include <string>
#include <math.h>
#include <ctype.h>
#include <vector>
#include <algorithm>

using namespace std;

class CGate  
{
 public:

  CGate();

  CGate(const CGate &);
  
  CGate(const char*, int);	

  const CGate &operator=(const CGate &);

  bool operator==(const CGate &) const;

  bool operator<(const CGate &) const;

  virtual ~CGate();

  char           m_name[10];
  int            m_id;
  int            m_nFanIn;
  int            m_nFanOut;
  double         m_r;
  double         m_R;
  double         m_c;
  double         m_C;
  double         m_cFET;
  double         m_mu;
  vector<double> m_vLambda;
  vector<double> m_vArrivalTime;
  double         m_Delay;
  double         m_size;         
  double         m_sizeBound[2];
  bool           m_primaryOutput;
  
};


