/********************************************************************************
* Fast and Exact Gate Sizing by Lagrangian Relaxation                           *
* File name: GateData.h; interface for the CGateData class                      *
* Author: Yu-Hao Wang							        *
* Created      : 09/28/01						  	*
* Last modified: 02/01/02	       					        *
*********************************************************************************/

class CGateData  
{
 public:

  CGateData();
  virtual ~CGateData();

  const CGateData &operator=( const CGateData &One ) 
    {
      if ( &One != this ) {
	m_key   = One.m_key;
	m_c     = One.m_c;
	m_r     = One.m_r;
	m_cFET  = One.m_cFET;
	m_alpha = One.m_alpha;
	m_beta  = One.m_beta;
      }
      return *this;
    }

  int operator==( const CGateData &One ) const  
    {
      return (m_key == One.m_key);
    }

  int operator<( const CGateData &One ) const  
    {
      return (m_key < One.m_key);
    }

  int operator>( const CGateData &One ) const  
    {
      return (m_key > One.m_key);
    }

  int operator<=( const CGateData &One ) const  
    {
      return (m_key <= One.m_key);
    }

  int operator>=( const CGateData &One ) const
    {
      return (m_key >= One.m_key);
    }
  
  int      m_key;
  double   m_c,     
           m_r,
           m_cFET,
           m_alpha,
           m_beta;
};


