/********************************************************************************
* Fast and Exact Gate Sizing by Lagrangian Relaxation                           *
* File name: GateType.h: interface for the CGateType class                      *
* Author: Yu-Hao Wang								*
* Created      : 09/28/01					 		*
* Last modified: 02/01/02							*
*********************************************************************************/

#include <algorithm>
#include <vector>
#include "gateData.h"

using namespace std;  

class CGateType  
{
 public:

  CGateType();
  virtual ~CGateType();

  const CGateType &operator=( const CGateType &One ) 
    {
      if ( &One != this ) {
	strcpy(m_key, One.m_key);
	m_dataArray = One.m_dataArray;
      }
      return *this;
    }

  int operator==( const CGateType &One ) const
    {
      return (strcmp(m_key, One.m_key) == 0);
    }

  int operator<( const CGateType &One ) const  
    {
      return (strcmp(m_key, One.m_key) < 0);
    }

  int operator>( const CGateType &One ) const
    {
      return (strcmp(m_key, One.m_key) > 0);
    }

  int operator<=( const CGateType &One ) const
    {
      return (strcmp(m_key, One.m_key) < 0 || strcmp(m_key, One.m_key) == 0);
    }

  int operator>=( const CGateType &One ) const  
    {
      return (strcmp(m_key, One.m_key) > 0 || strcmp(m_key, One.m_key) == 0);
    }
  
  char              m_key[10];
  vector<CGateData> m_dataArray;
  
};

