/********************************************************************************
* Fast and Exact Gate Sizing by Lagrangian Relaxation                           *
* File name: SGWS_LR.cpp; defines the entry point for the console application   *
* Author: Yu-Hao Wang							 	*
* Created      : 09/28/01					        	*
* Last modified: 11/27/01							*
*********************************************************************************/

#include "netlist.h"

using namespace std;

int main(int argc, char* argv[])
{
  char inFile[20];
  char outFile[20];
  CNetlist netlist;

  if (argc >= 3) {
    strcpy(inFile, argv[1]);
    strcpy(outFile, argv[2]);
    if (argc == 4)
      netlist.m_Condition[0] = atof(argv[3]);
    else if (argc == 5) {
      netlist.m_Condition[0] = atof(argv[3]);
      netlist.m_Condition[1] = atof(argv[4]);
    }
    netlist.BuildDB("param.txt");
    netlist.InputNetlist(inFile);
    netlist.OutputResult(outFile);
  }
  else {
    cerr << "Usage Error: x.qt [input filename] [output filename] [*innerloop criterion %] [*outerloop criterion %]" << endl;
    cerr << "* Indicates optional field" << endl;
    exit( 1 );
  }

  return 0;
}


